rango/rango/urls.py
from django.conf.urls import url
from django.contrib import admin
from django.conf.urls import include
from rangoapp import views

from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    url(r'^$', views.index, name='index'),
    url(r'^rango/', include('rangoapp.urls')), # rangoapp urls handle
    url(r'^admin/', admin.site.urls),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT) # 1to serve static content from MEDIA_URL.

rango/rangoapp/urls.py
from django.conf.urls import url
from rangoapp import views

app_name = 'rangoapp'
urlpatterns = [
    url(r'^$', views.index, name='index'),
    url(r'about/$', views.about, name='about'),
    url(r'^add_category/$', views.add_category, name='add_category'),
    url(r'^category/(?P<category_name_slug>[\w\-]+)/$', views.show_category, name='show_category'),
    url(r'^category/(?P<category_name_url>\w+)/add_page/$', views.add_page, name='add_page'),
    url(r'^register/$', views.register, name='register'),
    url(r'^login/$', views.user_login, name="login"),
    url(r'^restricted/', views.restricted, name='restricted'),
    url(r'^logout/$', views.user_logout, name='logout'),

]

rango/templates/rango/about.html
{% extends "rango/base.html" %}
{% load staticfiles %}

{% block title_block %}
    About
{% endblock %}

{% block body_block %}
<h1>This tutorial has been put together by CARLOS</h1>
<img src="{% static "media/rango.jpg" %}" alt="Rango says about page">
{% endblock %}

rango/templates/rango/add_category.html
{% extends "rango/base.html" %}
{% load staticfiles %}

{% block title_block %}
    Add Category
{% endblock %}

{% block body_block %}
<form id="category_form" action="{% url 'rangoapp:add_category' %}" method="post">
    {% csrf_token %}
    {% for hidden in form.hidden_fields %}
        {{hidden}}
    {% endfor %}

    {% for field in form.visible_fields %}
        {{field.errors}}
        {{field.help_text}}
        {{field}}
    {% endfor %}
    <input type="submit" name="submit" value="Create Category">
</form>
{% endblock %}

rango/templates/rango/add_page.html
{% extends "rango/base.html" %}
{% load staticfiles %}

{% block title_block %}
	Add Page
{% endblock %}


{% block body_block %}
{% if category %}

<h1>Add a Page to {{category.name}}</h1>
<form id="page_form" method="post" action="{% url 'rangoapp:add_page' category.slug %}">
	{% csrf_token %}
	{% for hidden in form.hidden_fields %}
		{{ hidden }}
	{% endfor %}
	{% for field in form.visible_fields %}
		{{ field.errors }}
		{{ field.help_text }}
		{{ field }}
	{% endfor %}
	<input type="submit" name="submit" value="Add Page" />
</form>

{% else %}
	The specified category does not exist!
{% endif%}
{% endblock %}

rango/templates/rango/base.html
 <!DOCTYPE html>
 {% load rango_template_tags %}
 {% load staticfiles %}
 <html>
 <head>
     <title>Rango -
         {% block title_block %}
         How to Tango with Django!
         {% endblock %}
     </title>
</head>
<body>

    <div>
        {% block body_block %}
        {% endblock %}
    </div>

    <hr />

    <div>
        <ul>
            {% if user.is_authenticated %}
            <li><a href="{% url 'rangoapp:restricted' %}">Restricted Page</a></li>
            <li><a href="{% url 'rangoapp:logout' %}">Logout</a></li>
            <li><a href="{% url 'rangoapp:add_category' %}">Add a New Category</a></li>
            {% else %}
            <li><a href="{% url 'rangoapp:login' %}">Sign In</a></li>
            <li><a href="{% url 'rangoapp:register' %}">Sign Up</a></li>
            {% endif %}
            <li><a href="{% url 'rangoapp:about' %}">About</a></li>
            <li><a href="{% url 'rangoapp:index' %}">Index</a></li>
        </ul>
    </div>

    <div>
        {% block sidebar_block %}
        {% get_category_list category %}
        {% endblock %}
    </div>

</body>
</html>

rango/templates/rango/category.html
{% extends "rango/base.html" %}
{% load staticfiles %}

{% block title_block %}
	{{ category.name }}
{% endblock %}

{% block body_block %}
	{% if category %}
	<h1>{{ category.name }}</h1>
		{% if pages %}
		<ul>
			{% for page in pages %}
			<li><a href="{{ page.url }}">{{ page.title }}</a></li>
			{% endfor %}
		</ul>
		{% else %}
			<strong>No pages currently in category.</strong>
		{% endif %}
		<a href="{% url 'rangoapp:add_page' category.slug %}">Add a Page</a>
		{% else %}
		The specified category does not exist!
	{% endif %}
{% endblock %}

rango/templates/rango/cats.html
<ul>
{% if cats %}
    {% for c in cats %}
        {% if c == act_cat %}
            <li><strong><a href="{% url 'rangoapp:show_category' c.slug %}">{{c.name}}</a></strong></li>
        {% else %}
            <li><a href="{% url 'rangoapp:show_category' c.slug %}">{{c.name}}</a></li>
        {% endif %}
    {% endfor %}
{% else %}
    <li><strong>There are no Categories present.</strong></li>

{% endif %}
</ul>

rango/templates/rango/index.html
{% extends "rango/base.html" %}
	{% load staticfiles %}
	{% block title_block %}
		Index
	{% endblock %}
	{% block body_block %}
		<div>
        	<h1>Rango says...</h1>
			{% if user.is_authenticated %}
				Hello {{ user.username }}!
			{% else %}
				hey there partner!
			{% endif %}
		</div>
		<div>
			<div>
				<h3>Most Liked Categories</h3>
			</div>
         	{% if categories %}
             <ul>
                 {% for category in categories %}
                 	<li><a href="{% url 'rangoapp:show_category' category.slug %}">{{ category.name }}</a></li>
                 {% endfor %}
             </ul>
        	{% else %}
             	<strong>There are no categories present.</strong>
        	{% endif %}
			</div>

				<div>
					<div>
						<h3>Most Viewed Pages</h3>
					</div>
	         	   {% if pages %}
	             	<ul>
	                 {% for page in pages %}
	                 <li><a href="{{ page.url }}">{{ page.title }}</a></li>
	                 {% endfor %}
	             	</ul>
	        		{% else %}
	             <strong>There are no categories present.</strong>
	       	  		{% endif %}
			</div>

        <img src="{% static "images/rango.jpg" %}" alt="Picture of Rango" />

{% endblock %}

rango/templates/rango/login.html
{% extends "rango/base.html" %}
{% load staticfiles %}

{% block title_block %}
    Login
{% endblock %}

{% block body_block %}
<h1>Login to rango</h1>
<form id="login_form" action="{% url 'rangoapp:login' %}" method="post">
    {% csrf_token %}
    Username: <input type="text" name="username" value="" size="50"> <br />
    Password: <input type="password" name="password" value="" size="50"> <br />
    <input type="submit" value="submit">
</form>
{% endblock %}

rango/templates/rango/register.html
{% extends "rango/base.html" %}
{% load staticfiles %}

{% block title_block %}
    Register
{% endblock %}

{% block body_block %}
    <h1>About Page</h1>
    {% if registered %}
        Rango says: <strong>Thank You for registered</strong>
        <a href="{% url 'rangoapp:index' %}"> Return homepage. </a><br />
    {% else %}
        Rango says: <strong>Register here!</strong><br />
        <form id="user_form" action="{% url 'rangoapp:register' %}" method="post" enctype="multipart/form-data">
            {% csrf_token %}

            <!-- Display each form -->
            {{user_form.as_p}}
            {{profile_form.as_p}}
            <!-- Provide a button to click to submit the Form -->
            <input type="submit" name="submit" value="Register">
        </form>
    {% endif %}
{% endblock %}

rango/templates/rango/restricted.html
{% extends "rango/base.html" %}
	{% load staticfiles %}

	{% block title_block %}
		Restricted
	{% endblock %}


	{% block body_block %}
		<h1> Welcome to restricted content {{user.username}}
	{% endblock %}